package nl.naturalis.oaipmh.api;

import nl.naturalis.oaipmh.api.util.OaiUtil;

/**
 * Interface defining the capacity to decompose a resumption token into its
 * constitutent parts. Repositories that have special ways of paging through large
 * result sets can implement this interface and return an instance of it in their
 * implementation of {@link StandAloneRepository#getResumptionTokenParser()}. This
 * instance will then be used to decompose the resumption token. Otherwise the REST
 * layer will use the {@link ResumptionToken default implementation}.
 *
 * @author Ayco Holleman
 */
public interface ResumptionTokenParser {

  /**
   * Returns the default resumption parser, which is capable of parsing resumption
   * tokens generated by the
   * {@link ResumptionTokenGenerator#getDefaultTokenGenerator() token generator}.
   *
   * @return
   * @see OaiUtil#createDefaultResumptionToken(OaiRequest, int, int)
   */
  public static ResumptionTokenParser getDefaultParser() {
    return new ResumptionToken();
  }

  /**
   * Decompose the specified resumption token into its constituent parts and create a
   * new {@link OaiRequest} instance from them.
   *
   * @param resumptionToken
   * @return
   */
  OaiRequest parseResumptionToken(String resumptionToken)
      throws OaiProtocolException;

  /**
   * Decompose the resumption token within the proived {@code OaiRequest} object into
   * its constituent parts and use these to set the other properties in the request
   * object.
   *
   * @param request
   */
  void parseResumptionToken(OaiRequest request) throws OaiProtocolException;

}
